#include<stdio.h>
#include<stdlib.h>

/*-------------------------------
  Count the number of valuables
-------------------------------*/

int
Count_Parameters(char*  buffer)
{
    int terms;

    for(terms=0; *buffer != '\0'; buffer++){
        if(*buffer == '=') terms++;
    }
    return(terms);
}


/*----------------------------------------------
  Set pointers to each vals' names and values.
----------------------------------------------*/

void
Copy_Pointers(char **vname, char **vvalue, char *buffer)
{
	*vname++ = buffer;

/* Replace '&' or '=' by Null terminater
   and set pointers to the next character. */

	while(1){
		switch(*++buffer){
		case '\0': 
			return;
		case '&': 
			*buffer = '\0';
			*vname ++ = buffer+1;
			break;
		case '=':
			*buffer = '\0';
			*vvalue++ = buffer+1;
			break;
		default:
			break;
		}
	}
}

/*--------------------
  Convert HEX to TEN.
---------------------*/

char
Hex(char c)
{
    if('0' <= c && c <= '9'){
        return(c - '0');
    }
    if('A' <= c && c <= 'F'){
        return(c - 'A' + 10);
    }
    return(-1);
}


/*------------------------------
  Decoding escaped characters.
------------------------------*/

void
Decode_Escape(char* string)
{
    int n=0;
    int m=0;
    char c;
    char temp;

    while((c = string[n++]) != '\0'){
        switch(c){

            /* special characters as "%1A". */
            case '%':
                string[m++] = (Hex(string[n])<<4) + Hex(string[n+1]) ;
                n+=2;
		break;

            /* '+' (space). */
            case '+':
                string[m++] = ' ';
		break;

            /* normal charaters. */
            default:
                string[m++] = c;
		break;
        }
    }
    string[m] = '\0';
}


/*-------------------------------------------------
  Get addresses where vals' names and values exist.
---------------------------------------------------*/

void
Get_Valuables( char*** vname, char*** vvalue, int* terms )
{
	int n, i;
	int length;
	char *buffer;

	if(getenv("CONTENT_LENGTH") == NULL){
		printf("Please execute this program on WWW.\n");
		exit(1);
	}

	length = atoi(getenv("CONTENT_LENGTH"));
	buffer = (char *)malloc(sizeof(char) * length);

	n = fread(buffer, 1, length, stdin);
	buffer[ n ] = '\0' ;

	*terms = Count_Parameters(buffer) ;

	*vname  = (char **)malloc(sizeof(char) * *terms) ;
	*vvalue = (char **)malloc(sizeof(char) * *terms) ;

	Copy_Pointers(*vname, *vvalue, buffer) ;

	for(i=0 ; i<*terms ; i++){
		Decode_Escape(*vvalue[i]);
	}
}

/*------------------------------------
  Get valuables from GET method.
--------------------------------------*/
int
Get_Valuables_Get(char*** vname, char*** vvalue, int* terms)
{	
	int n;
	int i;
	char *buffer;
	
	if(getenv("QUERY_STRING") == NULL){
		printf("please execute this program on WWW.");
		exit(1);
	}else{
		n = strlen(getenv("QUERY_STRING"));
		buffer = (char *)malloc(sizeof(char *) * n);
		strcpy(buffer, getenv("QUERY_STRING"));
		buffer[ n ] = '\0' ;
		
		*terms = Count_Parameters(buffer);
		
		if(*terms == 0){
			return(NULL);
		}else{
			*vname  = (char **)malloc(sizeof(char) * *terms);
			*vvalue = (char **)malloc(sizeof(char) * *terms);
			
			Copy_Pointers(*vname, *vvalue, buffer);
			
			for(i=0; i<*terms; i++){
				Decode_Escape(*vvalue[i]);
			}
			return(1);
		}
	}
}
